package schedframe.scheduling.manager.resources;

import java.util.Map;

import schedframe.resources.units.ResourceUnit;
import schedframe.resources.units.ResourceUnitName;

public interface ResourceAllocation {
	
	/**
	 * Allocates resource units( marks as used) on the basis of given resource
	 * units.
	 * 
	 * @param freeRes
	 *            resource units to be consumed
	 * @param exclusive
	 *           allocate resources in exclusive mode
	 */
	public boolean allocateResources(Map<ResourceUnitName, ResourceUnit> freeRes, boolean exclusive);

	/**
	 * Frees given resource units.
	 * 
	 * @param lastUsedResources
	 *            resource units to be free
	 * @param exclusive
	 *            free resources allocated in exclusive mode
	 */
	public void freeResources(Map<ResourceUnitName, ResourceUnit> lastUsedResources, boolean exclusive);

	
}
